Bug 3896 - Samba4WINS behavior differs from WIn2k servers
Samba4WINS behavior differs from WIn2k servers
Status: RESOLVED FIXED
Product: Samba 4.0
Classification: Unclassified
Component: Other
unspecified
All Windows XP
: P3 major
: ---
Assigned To: Stefan Metzmacher
Andrew Bartlett
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2006-06-28 16:32 UTC by Bill Marshall
Modified: 2006-07-26 08:23 UTC (History)
2 users (show)

See Also:


Attachments
Samb4 wins server (29.29 KB, application/octet-stream)
2006-06-28 16:34 UTC, Bill Marshall
no flags Details
Trace 2 - win2k server (12.29 KB, application/octet-stream)
2006-06-28 16:35 UTC, Bill Marshall
no flags Details
fix for the problem (866 bytes, patch)
2006-06-29 13:37 UTC, Stefan Metzmacher
no flags Details
better fix... (895 bytes, patch)
2006-06-29 14:18 UTC, Stefan Metzmacher
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Bill Marshall 2006-06-28 16:32:44 UTC
Here are the traces that show the difference between Win2k WINS server and Samba4 WINS server for the following scenario:

1.  There is a name registered in WINS that is no longer in use.
2.  There is a windows client using that IP that has a different name.
3.  A client tries to register the name no longer in use.


In trace 1 the client with IP 192.168.1.30 is trying to register the name XPCLIENT1A#00.  See in packet number 13 that Samba does not include the flags in the answers section of the wait for acknowledgement packet.

In trace 2, the client with IP 192.168.1.30 taking the XPCLIENT2#00 name.  See the correct format in packet 4 from a Win2k WINS server.

The malformed wack packet seems to cause the client to continually request the name.
Comment 1 Bill Marshall 2006-06-28 16:34:56 UTC
Created attachment 1999 [details]
Samb4 wins server
Comment 2 Bill Marshall 2006-06-28 16:35:30 UTC
Created attachment 2000 [details]
Trace 2 - win2k server
Comment 3 Stefan Metzmacher 2006-06-29 13:35:25 UTC
I've reproduced this, and I'll attach the fix now
Comment 4 Stefan Metzmacher 2006-06-29 13:37:11 UTC
Created attachment 2005 [details]
fix for the problem
Comment 5 Stefan Metzmacher 2006-06-29 14:18:34 UTC
Created attachment 2006 [details]
better fix...

this is a better patch, as we're only allowed to look 
at rdata.data.length in ndr_push mode
Comment 6 Stefan Metzmacher 2006-07-26 08:23:31 UTC
the fix is applied in revision 16691
and is part of samba4wins-1.0.4